.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::sfinddialog 0.4" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::sfinddialog\f[R] \- snit toplevel dialog for text search in
other widgets.
A implementation to search a text widget inbuild.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgw::sfinddialog
namespace import ::dgw::sfinddialog
sfinddialog pathName options
pathName configure \-findcmd script
pathName configure \-findnextcmd script
pathName configure \-textvariable varname
pathName configure \-nocase boolean
pathName configure \-word boolean
pathName configure \-regexp boolean
pathName configure \-title string
pathName cancel cmd options
pathName entry cmd options
pathName find cmd options
pathName next cmd options
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]sfinddialog\f[R] \- is a toplevel search dialog to perform a text
search in other widgets.
As such functionalitye is mostly required for the Tk text widget, a
implementation to search a Tk text widget is embedded within the
\f[B]sfinddialog\f[R] widget.
The buttons and the text entry are exposed to the programmer, so the
programmer has for instance the possibility to manually insert a value
in the search entry or to click a button programmatically.
.SS COMMAND
.PP
\f[B]sfinddialog\f[R] \f[I]pathName ?options?\f[R]
.RS
.PP
Creates and configures the sfinddialog toplevel widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
\f[B]\-findcmd\f[R] \f[I]script\f[R]
.RS
.PP
Set a command if the user clicks on the find button.
Please note, that if you would like to add search functionality to a Tk
text widget, just use the \f[I]\-textwidget\f[R] option described below.
.RE
.PP
\f[B]\-findnext\f[R] \f[I]script\f[R]
.RS
.PP
Set a command if the clicks on the next button.
Please note, that if you would like to add search functionality to a Tk
text widget, just use the \f[I]\-textwidget\f[R] option described below.
.RE
.IP
.nf
\f[C]
    global textvar
    testing mFind
    proc Next {} {
       global textvar
       wm title .s \[dq]Next $textvar words: [.s cget \-word]\[dq]
       puts \[dq]Next $textvar words: [.s cget \-word]\[dq]
    }
    proc Find {} {
       global textvar
       wm title .s \[dq]Find $textvar words: [.s cget \-word]\[dq]
       puts \[dq]Find $textvar words: [.s cget \-word]\[dq]
    }
    set textvar test
    dgw::sfinddialog .s \-nocase 1 \-findnextcmd Next \-findcmd Find \-textvariable textvar
    wm title .s \[dq]Search \[dq]
\f[R]
.fi
.PP
\f[B]\-forward\f[R] \f[I]boolean\f[R]
.RS
.PP
Checkbox configuration to indicate the search direction.
This value can be modified by the user later by clicking the checkbutton
belonging to this option.
.RE
.PP
\f[B]\-nocase\f[R] \f[I]boolean\f[R]
.RS
.PP
Sets the default value for the checkbox related to case insensitive
search.
This value can be modified by the user later by clicking the checkbutton
belonging to this option.
.RE
.PP
\f[B]\-regexp\f[R] \f[I]boolean\f[R]
.RS
.PP
Checkbox configuration to indicate if the search string should be used
as regular expression.
This value can be modified by the user later by clicking the
checkbutton.
.RE
.PP
\f[B]\-textvariable\f[R] \f[I]varname\f[R]
.RS
.PP
Configures the entry text to be synced with the variable
\f[I]varname\f[R].
.RE
.PP
\f[B]\-textwidget\f[R] \f[I]pathname\f[R]
.RS
.PP
The existing textwidget will get functionality to be searched by the
sfinddialog.
Here is an example on how to use it for a text widget:
.RE
.IP
.nf
\f[C]
     pack [text .text]
     dgw::sfinddialog .st \-nocase 0 \-textwidget .text \-title \[dq]Search\[dq]
     .text insert end \[dq]Hello\[rs]n\[dq]
     .text insert end \[dq]Hello World!\[rs]n\[dq]
     .text insert end \[dq]Hello Search Dialog!\[rs]n\[dq]
     .text insert end \[dq]End\[rs]n\[dq]
     .text insert end \[dq]How are your?\[rs]n\[dq]
     .text insert end \[dq]I am not prepared :(\[rs]n\[dq]
   
     bind .text <Control\-f> {wm deiconify .st}
\f[R]
.fi
.PP
\f[B]\-title\f[R] \f[I]string\f[R]
.RS
.PP
Sets the title of the sfinddialog toplevel.
.RE
.PP
\f[B]\-word\f[R] \f[I]boolean\f[R]
.RS
.PP
Checkbox configuration to indicate that the search should be performed
on complete words.
This value can be modified by the user later by clicking the checkbutton
belonging to this option.
Please note that this works currently only together with regular
expressions, even if the option is not set in the dialog.
.RE
.SS WIDGET COMMANDS
.PP
Each \f[B]sfinddialog\f[R] toplevel supports the following widget
commands.
.PP
\f[I]pathName\f[R] \f[B]cancel\f[R] \f[I]cmd ?option \&...?\f[R]
.RS
.PP
This function provides access for the programmer to the cancel button.
For instance to close the dialog it is possible to use: \f[I]pathName
cancel invoke\f[R].
See the button manual page for other commands.
.RE
.PP
\f[I]pathName\f[R] \f[B]cget\f[R] \f[I]option\f[R]
.RS
.PP
Returns the given sfinddialog configuration value for the option.
.RE
.PP
\f[I]pathName\f[R] \f[B]configure\f[R] \f[I]option value ?option
value?\f[R]
.RS
.PP
Configures the sfinddialog toplevel with the given options.
.RE
.PP
\f[I]pathName\f[R] \f[B]entry\f[R] \f[I]cmd ?option \&...?\f[R]
.RS
.PP
This function provides access for the programmer to the embedded entry
widget.
For instance to get the current text you could use: \f[I]pathName entry
get\f[R].
See the entry manual page for other commands available for the entry
widget.
.RE
.PP
\f[I]pathName\f[R] \f[B]find\f[R] \f[I]cmd ?option \&...?\f[R]
.RS
.PP
This function provides access for the programmer to the find button.
For instance to execute the search it is possible to use: \f[I]pathName
find invoke\f[R].
See the button manual page for other commands.
.RE
.PP
\f[I]pathName\f[R] \f[B]findnext\f[R] \f[I]cmd ?option \&...?\f[R]
.RS
.PP
This function provides access for the programmer to the findnext button.
For instance to execute the next search it is possible to use:
\f[I]pathName findnext invoke\f[R].
See the button manual page for other commands.
.RE
.SS EXAMPLE
.IP
.nf
\f[C]
proc Test_Find {} {
   global textvar
   # testing mFind
   proc Next {} {
       global textvar
       wm title .s \[dq]Next $textvar words: [.s cget \-word]\[dq]
       puts \[dq]Next $textvar words: [.s cget \-word]\[dq]
   }
   proc Find {} {
       global textvar
       wm title .s \[dq]Find $textvar words: [.s cget \-word]\[dq]
      puts \[dq]Find $textvar words: [.s cget \-word]\[dq]
   }
   
   set textvar test
   dgw::sfinddialog .s \-nocase 1 \-findnextcmd Next \-findcmd Find \-textvariable textvar
   wm title .s \[dq]Search \[dq]
  
   .s find configure \-bg red
   set btn [.s find]
   $btn configure \-bg blue
   bind .s <Control\-f> {wm deiconify .s}
   pack [button .btn \-text \[dq]Open find dialog again ...\[dq] \-command {wm deiconify .s}]
   pack [text .text]
   dgw::sfinddialog .st \-nocase 0 \-textwidget .text \-title \[dq]Search\[dq]
   .text insert end \[dq]Hello\[rs]n\[dq]
   .text insert end \[dq]Hello World!\[rs]n\[dq]
   .text insert end \[dq]Hello Search Dialog!\[rs]n\[dq]
   .text insert end \[dq]End\[rs]n\[dq]
   .text insert end \[dq]How are your?\[rs]n\[dq]
   .text insert end \[dq]I am not prepared :(\[rs]n\[dq]
   
   bind .text <Control\-f> {wm deiconify .st}
}
Test_Find
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can install and use the
\f[B]dgw::sfinddialog\f[R] package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
If you have the snit Tcl packages installed, you can either use the
sfinddialog package by sourcing it with:
\f[C]source /path/to/sfinddialog.tcl\f[R], by copying the folder
\f[C]dgw\f[R] to a path belonging to your Tcl \f[C]$auto_path\f[R]
variable or by installing it as a Tcl module.
To do the latter, make a copy of \f[C]sfinddialog.tcl\f[R] to a file
like \f[C]sfinddialog\-0.4.tm\f[R] and put this file into a folder named
\f[C]dgw\f[R] where the parent folder belongs to your module path.
You must eventually adapt your Tcl\-module path by using in your Tcl
code the command: \f[C]tcl::tm::path add /parent/dir/\f[R] of the
\f[C]dgw\f[R] directory.
For details of the latter, consult the manual page of
tcl::tm (https://www.tcl.tk/man/tcl/TclCmd/tm.htm).
.PP
Alternatively there is an \f[C]\-\-install\f[R] option you can use as
well.
Try: \f[C]tclsh sfinddialog.tcl \-\-install\f[R] which should perform
the procedure described above automatically.
This requires eventually the setting of an environment variables like if
you have no write access to all your module paths.
For instance on my computer I have the following entry in my
\f[C].bashrc\f[R]
.IP
.nf
\f[C]
export TCL8_6_TM_PATH=/home/groth/.local/lib/tcl8.6
\f[R]
.fi
.PP
If I execute \f[C]tclsh sfinddialog.tcl \-\-install\f[R] the file
\f[C]sfinddialog.tcl\f[R] will be copied to
\f[C]/home/groth/.local/lib/tcl8.6/dgw/sfinddialog\-0.1.tm\f[R] and is
thereafter available for a \f[C]package require dgw::sfinddialog\f[R].
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish sfinddialog.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ wish sfinddialog.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh sfinddialog.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh sfinddialog.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]sfinddialog.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh sfinddialog.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown processor for
conversion into a man page, a html or a pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
# man page
tclsh sfinddialog.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > sfinddialog.n
# html page
tclsh ../sfinddialog.tcl \-\-man > sfinddialog.md
pandoc \-i sfinddialog.md \-s \-o sfinddialog.html
# pdf
pandoc \-i sfinddialog.md \-s \-o sfinddialog.tex
pdflatex sfinddialog.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \- package homepage:
http://chiselapp.com/user/dgroth/repository/tclcode/index (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.SS TODO
.IP \[bu] 2
probably as usually more documentation
.IP \[bu] 2
more, real, tests
.IP \[bu] 2
github url for putting the code
.SS AUTHOR
.PP
The \f[B]sfinddialog\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
.SS COPYRIGHT
.PP
Copyright (c) 2019 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.SS LICENSE
.PP
Text search dialog widget dgw::sfinddialog, version 0.4.
.PP
Copyright (c) 2019 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
